//
//  LSClef.java
//  LiveScore
//
//  Created by harris wulfson on 7/29/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

package com.wulfson.livescore;

import java.awt.*;

public class LSClef
{
	final static int BASS = 1;
	final static int TREBLE = 2;
	final static int ALTO = 3;
	final static int TENOR = 4;
	final static int TREBLE8 = 5;
	final static int PERC = 6;
	//OCTAVE_TREBLE?

	int _type;
	int _steps; //TODO: really spaces
	int _middleCSteps; //from center line
	String _string;
	String _label;
	LSStaff _staff;
	
	//TODO: this is wrong. the static constants should be Clef objects, and 
	//the constructor should take string, steps, label as arguments. 
	public LSClef(int type)
	{
		_type = type;
		this.initStrings();
	}

	public void paint(Graphics g)
	{
		//draw string
		Graphics2D g2 = (Graphics2D)g;
		float space;
		
		space=_staff.getSystem().getPage().getSpace();
		g2.setFont(new Font("Maestro", Font.PLAIN, (int)(space * 4.0f))); //TODO
		g2.drawString(_string, _staff.getSystem().getLeftX() + (space * 1.1f), _staff.getYpos() - (space * _steps));
	}

	private void initStrings()
	{
		if(_type == LSClef.BASS)
		{
			_string = "?";
			_steps = 1;
			_label = "bass";
			_middleCSteps = 6;
		}
		else if(_type == LSClef.TREBLE)
		{
			_string = "&";
			_steps = -1;
			_label = "treble";
			_middleCSteps = -6;
		}
		else if(_type == LSClef.ALTO)
		{
			_string = "B";
			_steps = 0;
			_label = "alto";
			_middleCSteps = 0;
		}
		else if(_type == LSClef.TENOR)
		{
			_string = "B";
			_steps = 1;
			_label = "tenor";
			_middleCSteps = 2;
		}
		else if(_type == LSClef.TREBLE8)
		{
			_string = "V";
			_steps = -1;
			_label = "tenor";
			_middleCSteps = 1;
		}
		else if(_type == LSClef.PERC)
		{
			_string = "/";
			_steps = -1;
			_label = "percussion";
			_middleCSteps = 0;
		}
	}

	public LSStaff getStaff()
	{
		return _staff;
	}
	public void setStaff(LSStaff aStaff)
	{
		_staff = aStaff;
	}
	public int getMiddleCSteps()
	{
		return _middleCSteps;
	}
	
	
}
