package com.wulfson.livescore;
//
//  LSSystem.java
//  LiveScore
//
//  Created by harris wulfson on 7/26/07.
//  Copyright 2007. All rights reserved.
//

//package

import java.awt.*;
import java.awt.geom.Line2D;
import java.util.*;

public class LSSystem
{
	LSPage _page;
	LSSystem _nextSystem;
	ArrayList<LSStaff> _staves;
	float _yoffset;
	float _leftX;
	float _rightX;
	float _conductorX;
	
	public LSSystem(float yoffset)
	{
		_staves=new ArrayList();
		_leftX = 30;
		_rightX = 750;
		_yoffset=yoffset;
	}

	public void paint(Graphics g)
	{
		Iterator i;
		LSStaff aStaff;
		
		i=_staves.iterator();
		while(i.hasNext())
		{
			aStaff=(LSStaff)i.next();
			aStaff.paint(g);
		}
		this.drawBarlines(g);
	}

	public void drawBarlines(Graphics g)
	{
		Graphics2D g2;
		float space;
		LSStaff top, bottom;
		
		space=_page.getSpace();
		top=(LSStaff)_staves.get(0);
		bottom=(LSStaff)_staves.get(_staves.size() - 1);
		
		top = (LSStaff)_staves.get(0);
		bottom = (LSStaff)_staves.get(_staves.size() - 1);
		
		//Draw system caps
		g2 = (Graphics2D)g;
        g2.setStroke(new BasicStroke(space * 0.16f)); //TODO 0.16

        //TODO: this assumes 5-line staff.
        g2.draw(new Line2D.Float(_leftX, top.getYpos() - (space * 2),
				_leftX, bottom.getYpos() + (space * 2)));
		g2.draw(new Line2D.Float(_rightX, top.getYpos() - (space * 2),
				_rightX, bottom.getYpos() + (space * 2)));

	}


	//Accessors
	public LSPage getPage()
	{
		return _page;
	}

	public void setPage(LSPage aPage)
	{
		_page = aPage;
	}

	public ArrayList<LSStaff> getStaves()
	{
		return _staves;
	}

	public void addStaff(LSStaff aStaff)
	{
		_staves.add(aStaff);
		aStaff.setSystem(this);
	}
	public LSStaff getTopStaff()
	{
		return _staves.get(0);
	}
	public LSStaff getBottomStaff()
	{
		return _staves.get(_staves.size() - 1);
	}
	
	public float getYoffset()
	{
		return _yoffset;
	}

	public void setYoffset(float aYoffset)
	{
		_yoffset = aYoffset;
	}

	public float getYpos()
	{
		return _yoffset * _page.getSpace();
	}

	public float getLeftX()
	{
		return _leftX;
	}

	public void setLeftX(float aLeftX)
	{
		_leftX = aLeftX;
	}

	public float getRightX()
	{
		return _rightX;
	}

	public void setRightX(float aRightX)
	{
		_rightX = aRightX;
	}

	public LSSystem getNextSystem()
	{
		return _nextSystem;
	}

	public void setNextSystem(LSSystem nextSystem)
	{
		_nextSystem = nextSystem;
	}


}
